PROGRAM fortran_calls_c
USE, INTRINSIC :: iso_c_binding

! Declare an interface for the C function
INTERFACE

    SUBROUTINE calc(a, b, c) BIND(C)
    USE, INTRINSIC :: iso_c_binding
    REAL(KIND=C_FLOAT) :: a, b, c
    END SUBROUTINE calc
    
END INTERFACE

! Get data
WRITE(*,*) 'Enter a:'
READ (*,*) a
WRITE(*,*) 'Enter b:'
READ (*,*) b

! Call C function
CALL calc(a, b, c)

! Write output
WRITE (*,*) 'In Fortran: a + b = ', c

END PROGRAM fortran_calls_c