PROGRAM fortran_calls_c2
USE, INTRINSIC :: iso_c_binding
USE data_types

TYPE(my_type) :: my_struct
CHARACTER(KIND=C_CHAR),DIMENSION(20) :: c

! Declare an interface for the C function
INTERFACE

    SUBROUTINE c_sub(my_struct, msg) BIND(C)
    USE, INTRINSIC :: iso_c_binding
    USE data_types
    TYPE(my_type) :: my_struct
    CHARACTER(KIND=C_CHAR),DIMENSION(20) :: msg
    END SUBROUTINE c_sub
    
END INTERFACE

! Initialize data
my_struct%n = 3
my_struct%data1 = 6
my_struct%data2 = 0
c(1) = 'H'
c(2) = 'e'
c(3) = 'l'
c(4) = 'l'
c(5) = 'o'
c(6) = C_NULL_CHAR

! Write output before the call
WRITE (*,*) 'Output before the call:'
WRITE (*,*) 'my_struct%n     = ', my_struct%n
WRITE (*,*) 'my_struct%data1 = ', my_struct%data1
WRITE (*,*) 'my_struct%data2 = ', my_struct%data2

! Call C function
CALL c_sub(my_struct, c)

! Write output after the call
WRITE (*,*) 'Output after the call:'
WRITE (*,*) 'my_struct%n     = ', my_struct%n
WRITE (*,*) 'my_struct%data1 = ', my_struct%data1
WRITE (*,*) 'my_struct%data2 = ', my_struct%data2

END PROGRAM fortran_calls_c2